
#include <stdio.h>
#include "sage++user.h"

extern void analyse_reference(SgStatement *);
extern void show_Trans_Ref(SgStatement *);

void doSymb(SgSymbol *s) {
  printf("%s ",s->id(),s->identifier());
}

void doFullType(SgType *t) {
  switch(t->variant()) {
    case T_INT: printf("integer "); break;
    case T_FLOAT: printf("real "); break;
    default: break;
  }
}
 
main(int argc, char * argv[]){
  
  SgProject project("test", argc, argv);

  for (int i=0; i< project.numberOfFiles(); i++) {
    SgFile *f;

    f = &(project.file(i));

    // travel state

    SgStatement *s;

    for (s=f->firstStatement(); s; s=s->lexNext()) {
      if(s->variant()==PROCESSORS_STMT) {
	printf("Processor Statement's id: % 4d variant:  % 4d\n", s->id(), s->variant());
      };

      if(s->variant()==TEMPLATE_STMT) {
	printf("Template Statement's id: % 4d variant:  % 4d\n", s->id(), s->variant());
      };

      if(s->variant()==ALIGN_DECL) {
	printf("Align Statement's id: % 4d variant:  % 4d\n", s->id(), s->variant());
      };

      if(s->variant()==FORALL_STMT) {
	printf("Forall Statement's id: % 4d variant:  % 4d\n", s->id(), s->variant());
	
	int i;
	for (i=0; i < (s->numberOfChildrenList1()); i++) {
	  analyse_reference(s->childList1(i));
	};

      };
    };
      
      // printf("lastDeclaration Statement's id: % 4d variant:  % 4d\n\n", s->lastDeclaration()->id(), s->lastDeclaration()->variant());

    
    for (s=f->firstStatement(); s; s=s->lexNext()) {
      if(s->variant()==PROCESSORS_STMT) {
	printf("Processor Statement's id: % 4d variant:  % 4d\n", s->id(), s->variant());
      };

      if(s->variant()==TEMPLATE_STMT) {
	printf("Template Statement's id: % 4d variant:  % 4d\n", s->id(), s->variant());
      };

      if(s->variant()==ALIGN_DECL) {
	printf("Align Statement's id: % 4d variant:  % 4d\n", s->id(), s->variant());
      };

      if(s->variant()==FORALL_STMT) {
	printf("Forall Statement's id: % 4d variant:  % 4d\n", s->id(), s->variant());
	
	int i;
	for (i=0; i < (s->numberOfChildrenList1()); i++) {
	  show_Trans_Ref(s->childList1(i));
	};

      };

    };



    /*
    SgSymbol *symb;

    int i=0;

    for (symb=f->firstSymbol(); symb; symb=symb->next()) {
      i++;
      printf("The % 3dth symbol: id: % 3d\n", i, symb->id());
      printf("                   type: % 3d\n", (symb->type())->id());
    };


    SgSymbol *ptrsymb;

    ptrsymb = new SgVariableSymb("var_new");

    SgStatement *ptrstat;

    ptrstat = new SgReturnStmt();

    */


    f->saveDepFile("nodeProgram.dep");
  
  };

  return 0;

}






